using System;
using System.Data ;
using System.Collections  ;
using System.ComponentModel;

namespace SmartDS
{
	/// <summary>
	/// This SmartDS Version doesn't use DataSet metadata for Validation
	/// </summary>
	public class CSmartDS1 : DataSet 
	{
		public CSmartDS1()
		{
			this.Tables.CollectionChanged += 
				new CollectionChangeEventHandler(this.SchemaChangedHook);;
	//		this.Relations.CollectionChanged += schemaChangedHandler;
		}

		

		private void SchemaChangedHook(
			object sender, System.ComponentModel.CollectionChangeEventArgs e) 
		{
			if (e.Action == CollectionChangeAction.Add ) 
			{
				if (e.Element is DataTable )  
				{
					((DataTable)e.Element).ColumnChanging +=new DataColumnChangeEventHandler(DS_ColumnChanging); 
					((DataTable)e.Element).RowChanging +=new DataRowChangeEventHandler(DS_RowChanging);
				}
			}
			else if (e.Action == CollectionChangeAction.Remove ) 
			{
				if (e.Element is DataTable ) 
				{
					((DataTable)e.Element).ColumnChanging -=new DataColumnChangeEventHandler(DS_ColumnChanging); 
					((DataTable)e.Element).RowChanging -=new DataRowChangeEventHandler(DS_RowChanging);
				}
			
			}
		}



		virtual protected void OnColumnChanging(object sender, DataColumnChangeEventArgs e) 
		{
			//Inherited class will override this method to apply 
			//validation rules at field level
		}

		private void DS_ColumnChanging(object sender, DataColumnChangeEventArgs e)
		{
			OnColumnChanging(sender, e);
		}



		virtual protected void  OnRowChanging(object sender, DataRowChangeEventArgs e) 
		{
			//Inherited class will override this method to apply 
			//validation rules at row level
		}


		private void DS_RowChanging(object sender, DataRowChangeEventArgs e)
		{
			OnRowChanging(sender, e);
		}

		virtual protected void Validate(ArrayList p_errlist) 
		{
			//Inherited class will override this method to apply 
			//validation rules to provide DS wide validation
			//tipically triggered before the DS is persisted to the DB
		}
	}
}
